#include <BRepTools.hxx>
#include <BRep_Tool.hxx>
#include <TopoDS_Shape.hxx>
#include <TopoDS_Face.hxx>
#include <BRep_Builder.hxx>
#include <TopExp_Explorer.hxx>
#include <BRep_Tool.hxx>
#include <TopLoc_Location.hxx>
#include <Poly_Triangulation.hxx>
#include <BRepMesh_IncrementalMesh.hxx>
#include <BRepBuilderAPI_NurbsConvert.hxx>
#include <TopoDS.hxx>
#include <iostream>

int nbTriangle(const TopoDS_Face & s)
{
	BRepMesh_IncrementalMesh m(s, 7E-3, true);
	m.Perform();
	TopLoc_Location l;
	const Handle(Poly_Triangulation) & pt = BRep_Tool::Triangulation(s, l);
	return pt->NbTriangles();
}

int main()
{
	BRep_Builder bb;
	TopoDS_Shape shape;
	BRepTools::Read(shape, "square.brep", bb);
    const TopoDS_Face & face = TopoDS::Face(shape);
	cout << "Number of triangles for the sphere geometry: " << nbTriangle(face) << endl;
   	BRepBuilderAPI_NurbsConvert converter;
	converter.Perform(face);
	const TopoDS_Face & nurbs = (const TopoDS_Face &)converter.ModifiedShape(face);
	cout << "Number of triangles for the nurbs geometry: " << nbTriangle(nurbs) << endl;
	return 0;
}
